module Container.CartesianMorphism where

-- * Imports

-- ** Stdlib

open import Function
open import Relation.Binary.PropositionalEquality

open import Data.Product

-- ** Local

open import Container.Container
open import Container.Morphism

-- * Definition

record _⇒c[_∣_]_ {I+ I O+ O : Set}
                (φ+ : I+ ▸ O+)(forgetI+ : I+ → I)(forgetO+ : O+ → O)(φ : I ▸ O) : Set₁ where
  field
    forget : {o+ : O+} → S φ+ o+ → S φ (forgetO+ o+)
    pull : {o+ : O+}{sh+ : S φ+ o+} → P φ (forget sh+) ≡ P φ+ sh+
    simForget⊢ : {o+ : O+}(sh+ : S φ+ o+)(p : P φ (forget sh+)) →
                 forgetI+ (n φ+ (subst id pull p)) ≡ n φ p
open _⇒c[_∣_]_ public

_⇒c[_]_ : {O+ O : Set}(φ+ : O+ ▸ O+)(forgetO+ : O+ → O)(φ : O ▸ O) → Set₁
φ+ ⇒c[ forgetO+ ] φ = φ+ ⇒c[ forgetO+ ∣ forgetO+ ] φ


-- * Sub-category of Containers:

to⇒ : {I+ I O+ O : Set}{φ+ : I+ ▸ O+}{φ : I ▸ O}{reI : I+ → I}{reO : O+ → O} →
       φ+ ⇒c[ reI ∣ reO ] φ → φ+ ⇒[ reI ∣ reO ] φ
to⇒ τ = record { u = forget τ
               ; f = subst id (pull τ)
               ; sim⊢ = simForget⊢ τ }

-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
