module Container.Fixpoint where

-- * Imports

-- ** Stdlib

open import Data.Product

-- ** Local

open import Container.Container

-- * External fix-point

-- TODO It is an heresy to step outside for the fixed-point:
--      Internalize the fix point.

data μ {I : Set}(φ : I ▸ I)(i : I) : Set where
  <_> : (x : ⟦ φ ⟧ (μ φ) i) → μ φ i

out : {I : Set}{φ : I ▸ I}{i : I} → μ φ i → ⟦ φ ⟧ (μ φ) i
out < x > = x

-- * Induction principle

□ : {I : Set}(φ : I ▸ I)(X : I → Set)(Pred : {i : I} → X i → Set) → 
     {i : I} → ⟦ φ ⟧ X i → Set
□ φ X Pred {i} (sh , pos) = (p : P φ sh) → Pred (pos p)

inductionCont : {I : Set}
                (φ : I ▸ I)
                (Pred : {i : I} → μ φ i → Set)
                (m : {i : I}(x : ⟦ φ ⟧ (μ φ) i) → □ φ (μ φ) Pred x → Pred < x >)
                {i : I}(x : μ φ i) → Pred x
inductionCont φ Pred m < (sh , pos) > = m (sh , pos) (\p → inductionCont φ Pred m (pos p))

-- * Catamorphism

foldCont : {I : Set}
           {φ : I ▸ I}
           {P : I → Set}
           (m : {i : I} → ⟦ φ ⟧ P i → P i)
           {i : I}(x : μ φ i) → P i
foldCont {I}{φ}{P} m < (sh , pos) > = m (sh ,  λ p → foldCont m (pos p))

{- Or:

= inductionCont φ 
                (\{i} _ → P i) 
                (\xs ih → m (proj₁ xs , ih)) 
                x
-}

-- * Generalized induction

inductionCont' : {I : Set}
                 (φ : I ▸ I)
                 (X : I → Set)
                 (Pred : {i : I} → X i → Set)
                 (α : {i : I} → ⟦ φ ⟧ X i → X i)
                 (m : {i : I}(x : ⟦ φ ⟧ X i) → □ φ X Pred x → Pred (α x))
                 {i : I}(x : μ φ i) → Pred (foldCont α x)
inductionCont' φ X Pred α m x = inductionCont φ (λ x → Pred (foldCont α x)) help x
  where help : {i : _}(x : ⟦ φ ⟧ (μ φ) i) → 
               □ φ (μ φ) (λ x → Pred (foldCont α x)) x → 
               Pred (foldCont (λ {i} → α {i}) < x >) 
        help (sh , pos) p = m (sh , (λ p → foldCont α (pos p))) p


-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
