module Container.Morphism where

-- * Imports

-- ** Stdlib

open import Function
open import Relation.Binary.PropositionalEquality

open import Data.Product

-- ** Local

open import Pow
open import IProp

open import Container.Container

-- * Definition

record _⇒[_∣_]_ {I I' O O' : Set}
                (φ : I ▸ O)
                (reI : I → I')(reO : O → O')
                (φ' : I' ▸ O') : Set where
  field
    u : {o : O} → S φ o → S φ' (reO o)
    f : {o : O}{sh : S φ o} → P φ' (u sh) → P φ sh
    sim⊢ : {o : O}(sh : S φ o)(p' : P φ' (u sh)) →
              reI (n φ (f p')) ≡ n φ' p'
open _⇒[_∣_]_ public

_⇒[_]_ : {O O' : Set}(φ : O ▸ O)(reO : O → O')(φ' : O' ▸ O') → Set
φ ⇒[ reO ] φ' = φ ⇒[ reO ∣ reO ] φ'

_⇒_ : {O : Set}(φ : O ▸ O)(φ' : O ▸ O) → Set
φ ⇒ φ' = φ ⇒[ id ] φ'

-- * Extension

⟦_⟧⇒ : {I I' O O' : Set}{φ : I ▸ O}{φ' : I' ▸ O'}{reI : I → I'}{reO : O → O'} →
       (τ : φ ⇒[ reI ∣ reO ] φ') → (X : I' → Set)(o : O) →
       ⟦ φ ⟧ (X ∘ reI) o → ⟦ φ' ⟧ X (reO o)
⟦ τ ⟧⇒ X o (sh , pos) = u τ sh , \p → subst X (sim⊢ τ sh p) (pos (f τ p))



-- * Naturality:

lemmaSubst : {O' : Set}{X Y : O' → Set}{a b : O'} →
             (f : X ⟶ Y)
             (x : X a) →
             (q : a ≡ b) →
             f (subst X q x) ≡ subst Y q (f x)
lemmaSubst f x refl = refl

naturality : {O O' : Set}{φ : O ▸ O}{φ' : O' ▸ O'}{reO : O → O'} →
       (τ : φ ⇒[ reO ] φ') → (X : O' → Set)(Y : O' → Set)(o : O) →
       (F : {o' : O'} → X o' → Y o')
       (t : ⟦ φ ⟧ (X ∘ reO) o) →
       ⊢ ⟦ φ' ⟧Morph (λ {o'} → F {o'}) (⟦ τ ⟧⇒ X _ t) ≡ ⟦ τ ⟧⇒ Y _ (⟦ φ ⟧Morph (λ {o} x → F {reO o} x) t)
naturality τ X Y o F (sh , pos) = pure (cong (λ p → (u τ sh , p))) ⊛ 
                                       extensionality (λ x → 
                                         pure (lemmaSubst (λ{o'} → F {o'}) 
                                              (pos (f τ x)) 
                                              (sim⊢ τ sh x)))


-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
