module Example.AlgebraicOrnament where

open import Data.Empty
open import Data.Unit
open import Data.Product
open import Data.Sum

open import Relation.Binary.PropositionalEquality


open import Container.Container
open import Container.Fixpoint

open import Ornament.Ornament
open import Ornament.OrnamentalAlgebra
open import Ornament.AlgebraicOrnament

open import Example.Container
open import Example.Ornament


-- ** Example: Ornament by <_>

ListyCont : (A : Set) → (⊤ × (List' A)) ▸ (⊤ × (List' A))
ListyCont A = algebraicOrnament (ListCont A) <_>

Listy : (A : Set) → List' A → Set
Listy A l = μ (ListyCont A) (tt , l)

nily : {A : Set} → Listy A nil'
nily = < (((`0 , tt) , 
         (((`0 , tt) , ⊥-elim) , (refl , refl))) , \p → ⊥-elim p) >

consy : {A : Set}{l : List' A} → (a : A) → Listy A l → Listy A (cons' a l)
consy {l = l} a tl = < ( ((`suc , a) ,
                         (((`suc , a) , λ _ → l) , refl , refl)) , λ _ → tl ) >

-- ** Example: Vector from Nat + List

VectorCont' : (A : Set) → (⊤ × Nat) ▸ (⊤ × Nat)
VectorCont' A = algebraicOrnament (ListCont A) (ornamentalAlgebra (ListOrn A))

Vector' : Set → Nat → Set
Vector' A n = μ (VectorCont' A) (tt , n)

vnil'' : {A : Set} → Vector' A ze
vnil'' = < (((`0 , tt) , (((`0 , tt) , ⊥-elim) , refl , refl)) , \p → ⊥-elim p) >

vcons'' : {A : Set}{n : Nat} → A → Vector' A n → Vector' A (su n)
vcons'' {A} {n} x xs = < (((`suc , x) , (((`suc , x) , \_ → n) , refl , refl)) , \_ → xs) >
