{-# OPTIONS --type-in-type #-}

module Example.Lifting where

open import Data.Unit
open import Data.Product

open import Relation.Binary.PropositionalEquality

open import Container.Container
open import Container.Fixpoint

open import Lifting.Universe
open import Lifting.Patch
open import Lifting.Lifter

open import Example.Container
open import Example.Ornament


+Type : Type
+Type = μ NatCont [ tt ]⇒ μ NatCont [ tt ]⇒ μ NatCont [ tt ]× `⊤

α+ : Nat → ⟦ NatCont ⟧ (λ _ → Nat × ⊤) tt → Nat × ⊤
α+ xs (`0 , _) = xs , tt
α+ xs (`suc , n) = su (proj₁ (n tt)) , tt

_+_ : Nat → Nat → Nat × ⊤
_+_ xs = foldCont (α+ xs)


open import Example.AlgebraicOrnament

αvappend : {A : Set} → (n : Nat)(xs : Vector' A n)(m : Nat) → 
                   ⟦ VectorCont' A ⟧ (λ tm → Vector' A (proj₁ (n + (proj₂ tm))) × ⊤) (tt , m) → Vector' A (proj₁ (n + m)) × ⊤
αvappend n xs .(< (`0 , y) >) (((`0 , tt) , ((`0 , tt) , y) , refl , refl) , y') = xs , tt
αvappend n xs m (((`0 , _) , ((`suc , _) , _) , () , _) , _)
αvappend n xs m (((`suc , _) , ((`0 , _) , _) , () , _) , _)
αvappend n xs .(< (`suc , m) >) (((`suc , a) , ((`suc , .a) , m) , refl , refl) , pos) = vcons'' a (proj₁ (pos tt)) , tt


vappend : {A : Set} → (n : Nat)(xs : Vector' A n)(m : Nat)(ys : Vector' A m) → Vector' A (proj₁ (n + m)) × ⊤
vappend {A} n xs m ys = foldCont (λ {tm} → αvappend n xs (proj₂ tm)) ys

++P : Set → Patch +Type
++P A = μ⁺[ forgetList ] ListOrn A [ tt ∣ refl ]⇒ 
        μ⁺[ forgetList ] ListOrn A [ tt ∣ refl ]⇒
        μ⁺[ forgetList ] ListOrn A [ tt ∣ refl ]× `⊤


module Raw where

  help : (A : Set) → Lifter +Type (++P A) _+_
  help A n xs m ys = vappend n xs m ys 

  _++_ : (A : Set) → List' A → List' A → List' A × ⊤
  _++_ A = ⟦ ++P A ⟧PatchFun _+_ (help A)


module Alg where

  help : (A : Set) → Lifter +Type (++P A) _+_
  help A n xs = LiftAlg {_}{_}{_}{⊤}{forgetList}{ListOrn A}{_}{refl}{μ NatCont [ tt ]× `⊤}{μ⁺[ forgetList ] ListOrn A [ tt ∣ refl ]× `⊤} 
                        (α+ n) (λ {o+} → αvappend n xs ((proj₂ o+)))
  

  _++_ : (A : Set) → List' A → List' A → List' A × ⊤
  _++_ A = ⟦ ++P A ⟧PatchFun _+_ (help A)


