{-# OPTIONS --universe-polymorphism #-}

module IProp where

-- * Imports

-- ** Stdlib

open import Level

open import Data.Empty
open import Data.Unit
open import Data.Product

open import Category.Applicative
open import Category.Applicative.Indexed

open import Relation.Binary.PropositionalEquality



-- * Proof irrelvant universe of proofs

infixr 1 ⊢_
data ⊢_ {l : Level}(X : Set l) : Set l where
  pf : .X → ⊢ X


-- * ⊢ is an Applicative functor

Applicative⊢ : RawApplicative ⊢_
Applicative⊢ = record { pure = pf
                      ; _⊛_ = _⊛_ }
    where _⊛_ : {A B : Set} → ⊢ (A → B) → ⊢ A → ⊢ B
          (pf f) ⊛ (pf a) = pf (f a)

open RawIApplicative Applicative⊢ public

-- * Adding extensionality here is safe

postulate 
  extensionality : {A : Set}{B : A → Set}{f g : (a : A) → B a} →
                   ((x : A) → ⊢ f x ≡ g x) → ⊢ f ≡ g


-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
