module Lifting.Lifter where

-- * Imports

-- ** Stdlib

open import Function

open import Data.Product

open import Relation.Binary.PropositionalEquality

-- ** Local

open import Container.Container
open import Container.Fixpoint

open import Ornament.Ornament
open import Ornament.LiftOrnament

open import Lifting.Universe
open import Lifting.Patch

-- * Lifting algebras

-- TODO Better syntax?
-- TODO Better choice of implicit/explicit

LiftAlg : ∀ {O : Set}{φ}{o : O} → 
            {O+ : Set}{forget+ : O+ → O}{υ : Ornament1 φ O+ forget+}{o+ : O+}{q : forget+ o+ ≡ o}
          {T : Type}{P : Patch T}
          (α :  {o : O} → ⟦ φ ⟧ (λ o → ⟦ T ⟧LT) o → ⟦ T ⟧LT) → 
          (β : {o+ : Σ O+ (μ φ ∘ forget+)} → ⟦ liftCont υ ⟧ (λ o+ → Lifter T P (foldCont α (proj₂ o+))) o+ → Lifter T P (foldCont α (proj₂ o+))) →
          Lifter (μ φ [ o ]⇒ T) (μ⁺[ forget+ ] υ [ o+ ∣ q ]⇒ P) (foldCont α)
LiftAlg {q = refl} α β = λ t t++ → foldCont β t++

-- * Lifting constructors

{-
LiftConstructor : {!!}
LiftConstructor = {!!}
-}

-- * Lifting lambda

-- TODO When we have the polymorphic Pi

{-
LiftLam : ∀ {O : Set}{φ}{o : O} → 
            {O+ : Set}{υ : Ornament1 φ O+}{o+ : O+}{q : forget+ υ o+ ≡ o}
          {T : Type}{P : Patch T} →
          ? → 
          Lifter (∀[ A ] → T) (∀[ A ] → P) ?
LiftLam = {!!}
-}


-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
