module Lifting.Universe where

-- * Imports

-- ** Stdlib

open import Data.Product
open import Data.Unit

-- ** Local

open import Container.Container
open import Container.Fixpoint

-- * Type scheme

-- TODO Add dependent types
-- TODO Add function spaces

data Type : Set₁ where
     μ_[_]⇒_ : {O : Set}(φ : O ▸ O)(o : O) → (T : Type) → Type
     μ_[_]×_ : {O : Set}(φ : O ▸ O)(o : O) → (T : Type) → Type
     `⊤ : Type

-- * Interpretation

⟦_⟧LT : Type → Set
⟦ μ φ [ o ]⇒ T ⟧LT = μ φ o → ⟦ T ⟧LT
⟦ μ φ [ o ]× T ⟧LT = μ φ o × ⟦ T ⟧LT
⟦ `⊤ ⟧LT = ⊤


-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
