open import Container.Container

open import Ornament.Ornament

open import Data.Unit
open import Data.Sum
open import Data.Product

module Operator.Fixpoint (I J : Set) where


  module Fixpoint (φ : (I ⊎ J) ▸ I) where

    data μP (X : J → Set)(i : I) : Set where
      <_> : ⟦ φ ⟧ [ μP X , X ] i → μP X i

    Path : {X : J → Set}{i : I} → μP X i → Set
    Path {X} < sh , pos > = Σ[ p ∶ P φ sh ] help p
      where help : (p : P φ sh) → Set
            help p with n φ p | pos p
            help p | inj₁ i | t = Path t
            help p | inj₂ j | t = X j

    Next : {X : J → Set}{i : I}{sh : μP X i} → Path sh → J
    Next {X} {_} {< sh , pos >} (p , xs) with n φ p | pos p
    Next {X} {_} {< sh , pos >} (p , xs) | inj₁ i | t = Next xs
    Next {X} {_} {< sh , pos >} (p , xs) | inj₂ j | t = j

    μ : J ▸ I
    μ = record { S = μP (λ _ → ⊤)
               ; P = Path
               ; n = Next }

  open Fixpoint public

  module Functor {φ : (I ⊎ J) ▸ I}{I+ J+ : Set}(υ : Ornament φ (I+ ⊎ J+) I+) where

    μmap : Ornament (μ φ) J+ I+
    μmap = record {
             forgetI+ = {!λ j+ → forgetI+ υ ?!};
             forgetO+ = forgetO+ υ;
             extend = {!!};
             refine = {!!};
             coherence⊢ = {!!} }