module Ornament.AlgebraicFixpoint where

open import Data.Product

open import Relation.Binary.PropositionalEquality

open import Container.Container
open import Container.Fixpoint
open import Container.Morphism

-- TODO: Parameterize arguments into module

■ : {I : Set}(φ : I ▸ I){ψ : I ▸ I}(η : φ ⊸₀ ψ)(X : I → Set) → ({i : I} → X i → Set) → Σ I (⟦ ψ ⟧ X) → Set
■ φ η X Pred (i , xs) = Σ[ ys ∶ ⟦ φ ⟧ X i ] ⟦ η ⟧⊸₀ X i ys ≡ xs × ((p : P φ (proj₁ ys)) → Pred (proj₂ ys p))

-- TODO: this is the ornament Sigma_η ∘ φ^

lift : {I : Set}(φ : I ▸ I){ψ : I ▸ I}(η : φ ⊸₀ ψ) → Σ I (μ ψ) ▸ Σ I (μ ψ)
lift φ{ψ} η = record { S = λ ix → Σ[ c ∶ ⟦ φ ⟧ (μ ψ) (proj₁ ix) ]
                                  < ⟦ η ⟧⊸₀ (μ ψ) _ c > ≡ (proj₂ ix) 
                     ; P = λ sh → P φ (proj₁ (proj₁ sh))
                     ; n = λ {ix}{sh} p → n φ p , proj₂ (proj₁ sh) p }


postulate ext : Extensionality {!!} {!!}

dinduction : {I : Set}
             (φ : I ▸ I){ψ : I ▸ I}
             (X : I → Set)
             (Pred : {i : I} → X i → Set)
             (η : φ ⊸₀ ψ)
             (α : {i : I} → ⟦ ψ ⟧ X i → X i) →
             (β : {i : I}(x : ⟦ ψ ⟧ X i) → ■ φ η X Pred (i , x) → Pred (α x)) →
             {i : I} → (x : μ ψ i) → μ (lift φ η) (i , x) → Pred (foldCont α x)
dinduction {I} φ{ψ} X Pred η α β x t = 
  inductionCont (lift φ η) (λ {ix} t → Pred (foldCont α (proj₂ ix)) ) help t
    where help : {ix : Σ I (μ ψ)}(x : ⟦ lift φ η ⟧ (μ (lift φ η)) ix) → 
                     □ (lift φ η) (μ (lift φ η)) (λ {ix} t → Pred (foldCont α (proj₂ ix))) x → 
                     Pred (foldCont α (proj₂ ix))
          help {( i , < .(u₀ η shφ , λ p → subst (μ ψ) (sim₀⊢ η shφ p) (posφ (f₀ η p))) >)} (((shφ , posφ) , refl) , t') q = 
               β (u₀ η shφ , λ p → foldCont α (subst (μ ψ) (sim₀⊢ η shφ p) (posφ (f₀ η p)))) ((shφ , λ p → foldCont α (posφ p)) ,  cong (λ pos → ( u₀ η shφ , pos)) pf' , q)
               where pf' : (λ p → subst X (sim₀⊢ η shφ p) (foldCont (λ {a} → α {a}) (posφ (f₀ η p)))) ≡ 
                           (λ p → foldCont (λ {a} → α {a}) (subst (μ ψ) (sim₀⊢ η shφ p) (posφ (f₀ η p))))
                     pf' = ext (λ p → sym (lemmaSubst {I}{_}{_}{_}{_} (λ {i} → h {i}) (posφ (f₀ η p)) (sim₀⊢ η shφ p)))
                       where h : {i : I} → μ ψ i → X i
                             h = foldCont (λ {a} → α {a})
{-

lemmaSubst : {O' : Set}{X Y : O' → Set}{a b : O'} →
             (f : X ⟶ Y)
             (x : X a) →
             (q : a ≡ b) →
             f (subst X q x) ≡ subst Y q (f x)


Goal: (u₀ η shφ ,
       λ p →
         subst X (sim₀⊢ η shφ p) (foldCont (λ {.i} → α) (posφ (f₀ η p))))
      ≡ (shψ , λ p → foldCont (λ {.i} → α) (posψ p))

pf   : <
       u₀ η shφ , λ p → subst (μ ψ) (sim₀⊢ η shφ p) (posφ (f₀ η p)) >
       ≡ < shψ , posψ >


Forget : forall X, F X -> G X

X : Set
P : X -> Set
alpha : G X -> X
beta : F^Forget P -> alpha * P
-------------------------
ind X P alpha beta : (x : mu G) -> mu F^Forget x -> P (fold alpha x) 
-}
