open import Function

open import Data.Unit
open import Data.Product

open import Relation.Binary.PropositionalEquality

open import Pow

open import Container.Container
open import Container.Fixpoint

open import Ornament.Ornament

module Ornament.LiftOrnament {O O+ : Set}{φ : O ▸ O}{forget+ : O+ → O}
                             (υ : Ornament1 φ O+ forget+) where

open import Ornament.OrnamentalAlgebra
open import Ornament.AlgebraicOrnament



liftOrn : Ornament1 ⟨ υ ⟩o (Σ O+ (μ φ ∘ forget+)) proj₁
liftOrn = algebraicOrn ⟨ υ ⟩o (ornamentalAlgebra υ)


liftCont : Σ O+ (μ φ ∘ forget+) ▸ Σ O+ (μ φ ∘ forget+)
liftCont = ⟨ liftOrn ⟩o

doLift : {o+ : O+} → (x : μ ⟨ υ ⟩o o+) → μ liftCont (o+ , (forgetOrn υ x))
doLift x = makeAlgOrn ⟨ υ ⟩o (ornamentalAlgebra υ) x

indexLift : {o+ : O+}{t : μ φ (forget+ o+)} → μ liftCont (o+ , t) → μ φ (forget+ o+)
indexLift {o+}{t} _ = t

downLift :  {o+ : O+}{t : μ φ (forget+ o+)} → μ liftCont (o+ , t) → μ ⟨ υ ⟩o o+
downLift x = forgetOrn liftOrn x

