-- * Imports

-- * Stdlib

open import Function

open import Data.Product

-- ** Local

open import Pow

open import Container.Container
open import Container.Fixpoint
open import Container.Morphism
open import Container.CartesianMorphism

open import Ornament.Ornament

module Ornament.OrnamentalAlgebra {O O+ : Set}{φ : O ▸ O}{forget+ : O+ → O}
                                  (υ : Ornament1 φ O+ forget+) where


-- * Forgetful functor

forgetOrnament : (X : O → Set) → 
                 ⟦ ⟨ υ ⟩o ⟧ (X ∘ forget+) ⟶ (⟦ φ ⟧ X ∘ forget+)
forgetOrnament X = ⟦ to⇒ (toCartesian υ) ⟧⇒ X _

-- * Ornamental algebra

ornamentalAlgebra : ⟦ ⟨ υ ⟩o ⟧ (μ φ ∘ forget+) ⟶ (μ φ ∘ forget+)
ornamentalAlgebra = ζ ∘ (forgetOrnament (μ φ))
  where 
        ζ : ((⟦ φ ⟧ (μ φ)) ∘ forget+) ⟶ (μ φ ∘ forget+)
        ζ = <_>

-- * Forgetful map

forgetOrn : μ ⟨ υ ⟩o ⟶ ((μ φ) ∘ forget+)
forgetOrn = foldCont ornamentalAlgebra

-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
